package com.biotechvana.netools.models;


import java.util.HashMap;
import java.util.Map;

import org.jgrapht.graph.DefaultEdge;
import org.json.JSONObject;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonInclude;

@JsonAutoDetect(fieldVisibility = JsonAutoDetect.Visibility.ANY, getterVisibility = JsonAutoDetect.Visibility.NONE)
@JsonInclude(JsonInclude.Include.NON_NULL)
public class Edge extends DefaultEdge  implements IAttributable {
	
	private static final long serialVersionUID = 841822912303247608L;
	private String edgeID;
	private String sourceID;
	private String targetID;
    private String label;
    private String color;
    private String dashes;
    private double width;
    private String arrows;
    private String smooth;
    private double weight;
    
    public Edge() {
        
    }
    public Edge(String label) {
        this.label = label;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public String getColor() {
        return color;
    }

    public void setColor(String color) {
        this.color = color;
    }

    public String getDashes() {
        return dashes;
    }

    public void setDashes(String dashes) {
        this.dashes = dashes;
    }

    public double getWidth() {
        return width;
    }

    public void setWidth(double width) {
        this.width = width;
    }

    public String getArrows() {
        return arrows;
    }

    public void setArrows(String arrows) {
        this.arrows = arrows;
    }

    public String getSmooth() {
        return smooth;
    }

    public void setSmooth(String smooth) {
        this.smooth = smooth;
    }
	@Override
	public String getId() {
		
		return edgeID;
	}
	@Override
	public void setId(String id) {
		this.edgeID = id;
		
	}
	
	
	private Map<String, Object> customAttributes = new HashMap<>();
	@Override
	public Object getAttribute(String key) {
		return  customAttributes.get(key);
	}
	@Override
	public void setAttribute(String key, Object value) {
		Object oldValue = customAttributes.get(key);
        if (value.equals(oldValue)) return;
        customAttributes.put(key, value);
        // pcs.firePropertyChange(key, oldValue, value);
		
	}
	@Override
	public Map<String, Object> getAttributes() {
		return new HashMap<>(customAttributes);
	}
	public void setWeight(double weight) {
		this.weight = weight;
		
	}
	public double getWeight() {
		return weight;
	}
	public void setSource(String id2) {
		this.sourceID = id2;
		
	}
	
	public String getSource() {
		return sourceID;
	}
	
	public void setTarget(String id2) {
		this.targetID = id2;
		
	}
	
	public String getTarget() {
		return targetID;
	}
	public void toJson(JSONObject edgeJson) {
		edgeJson.put("id", getId());
		edgeJson.put("from", getSource());
		edgeJson.put("to", getTarget());
		edgeJson.put("label", getLabel());
        edgeJson.put("color", getColor());
        edgeJson.put("dashes", getDashes());
        edgeJson.put("width", getWidth());
        // edgeJson.put("arrows", edge.getArrows());
        edgeJson.put("arrows", getArrows());
        edgeJson.put("smooth", getSmooth());
		
	}
	
}


