package com.biotechvana.netools.projects;

import java.util.Objects;

// main function of the network design is to get a black list and white list of the network
// to infer a network structure from the data
class Arc {
    private Variable source;
    private Variable target;

    private String reason;
    
    public Arc(Variable source, Variable target) {
        this.source = source;
        this.target = target;
    }

    public Variable getSource() {
        return source;
    }

    public Variable getTarget() {
        return target;
    }
    
    public String getReason() {
        return reason;
    }

    public void setReason(String reason) {
        this.reason = reason;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Arc arc = (Arc) o;
        return Objects.equals(source, arc.source) && Objects.equals(target, arc.target);
    }

    @Override
    public int hashCode() {
        return Objects.hash(source, target);
    }
}